package com.tmax.openframe;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.file.*;
import com.tmax.openframe.variable.OIVPSAM_VariableContainer;
import com.tmax.openframe.variable.group.*;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 * <dl>
 * </dl>
 * <p>This describes files what declared in I/O sections: </p>
 * <ul>
 * <li>
 * IN-OIVPTEST-FILE: file class {@code ->} {@link OIVPSAM_FD_IN_OIVPTEST_FILE}, record class {@code -> } {@link OIVPSAM_PEOPLE_INFO}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * </ul>
 */
public class OIVPSAM implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPSAM_VariableContainer container = new OIVPSAM_VariableContainer();
    OIVPSAM_FD_IN_OIVPTEST_FILE FD_IN_OIVPTEST_FILE;
    Runnable INITIALIZATION = this::INITIALIZATION;
    Runnable MAINLINE = this::MAINLINE;
    Runnable FINALIZATION = this::FINALIZATION;
    Runnable _1000_READ = this::_1000_READ;
    Runnable _1000_READ_EXIT = this::_1000_READ_EXIT;
    Runnable _2000_MAINLINE_PROC = this::_2000_MAINLINE_PROC;
    Runnable _2000_MAINLINE_EXIT = this::_2000_MAINLINE_EXIT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(INITIALIZATION);
        MethodFlow.add(MAINLINE);
        MethodFlow.add(FINALIZATION);
        MethodFlow.add(_1000_READ);
        MethodFlow.add(_1000_READ_EXIT);
        MethodFlow.add(_2000_MAINLINE_PROC);
        MethodFlow.add(_2000_MAINLINE_EXIT);
    }

    public OIVPSAM() {
        FD_IN_OIVPTEST_FILE = new OIVPSAM_FD_IN_OIVPTEST_FILE();
    }

    public @Override void run() {
        run(INITIALIZATION, _2000_MAINLINE_EXIT);
    }

    private void run(Runnable start) {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    public void init() {
        container = new OIVPSAM_VariableContainer();
        FD_IN_OIVPTEST_FILE = new OIVPSAM_FD_IN_OIVPTEST_FILE();
    }

    void INITIALIZATION() {
    }

    void MAINLINE() {
        run(_1000_READ, _1000_READ_EXIT);
        if (GoTo != null || Return) {
            return;
        }
        while (!(StringUtils.stripEnd(container.getEOF_SW(), " ")
                .compareTo("Y") == 0)) {
            run(_2000_MAINLINE_PROC, _2000_MAINLINE_EXIT);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void FINALIZATION() {
        Return = true;
        return;
    }

    void _1000_READ() {
        OIVPSAM_PEOPLE_INFO temp_OIVPSAM_PEOPLE_INFO1;
        temp_OIVPSAM_PEOPLE_INFO1 = FD_IN_OIVPTEST_FILE.readNext();
        if (temp_OIVPSAM_PEOPLE_INFO1 != null) {
            container.setPEOPLE_INFO(temp_OIVPSAM_PEOPLE_INFO1);
        } else if (FD_IN_OIVPTEST_FILE.getFileStatus() == FileStatus.AT_END_CONDITION_SEQUENCED) {
            container.setEOF_SW("Y");
        }
        System.out.print("READ   RECORD: ");
        System.out.println(container.getPEOPLE_INFO());
    }

    void _1000_READ_EXIT() {
    }

    void _2000_MAINLINE_PROC() {
        run(_1000_READ, _1000_READ_EXIT);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _2000_MAINLINE_EXIT() {
    }
}
